
/* Copyright (C) 1993 Free Software Association of Germany

   The following is only valid, if you use this outside the Federal
   Republic of Germany.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   If you don't have a a copy of the GNU General Public License
   write to the Free Software Foundation, Inc., 675 Mass Ave, 
   Cambridge, MA 02139, USA.

   (C)opyright 1993,1994 FREE SOFTWARE ASSOCIATION OF GERMANY

   ----------------------------------------------------------------

   Fuer die Nutzung dieses Quell-Codes innerhalb der Bundesrepublik
   Deutschland gilt:

   Dieses Programm ist freie Software und kann unter den Bedingungen
   der Deutschen Free Software Lizenz weitergeben und/oder modifiziert
   werden.

   Wir haben dieses Programm in der Hoffnung entwickelt, dass es
   sich als nuetzlich erweist. Wir uebernehmen jedoch *KEINERLEI*
   Garantien auf die Funktion oder Verwendbarkeit dieses Programms.
   Der Anwender nutzt dieses Programm * AUF EIGENES RISIKO *

   Diesem Programm sollte eine Kopie der Deutschen Free Software Lizenz
   (DFSL) beigefuegt sein. Falls nicht, kann eine Kopie von uns angefordert
   werden: Free Software Association of Germany, Heimatring 19,
   60596 Frankfurt (info@elara.fsag..de), Telefon: ++49 - 69 - 6312083

   (C)opyright 1993,1994 FREE SOFTWARE ASSOCIATION OF GERMANY */

#include <stdio.h>
#include <fcntl.h>
#include <stdio.h>
#include <fcntl.h>
#include "tables.h"



#ifndef lint
static	char copyright[] =
"@(#) Copyright (c) 1993, 1994 Free Software Association of Germany.\n";
#endif

#ifndef lint
static char sccsid[] = "@(#) mtalkd  Version 0.90 Fri 25 Mar 1994 15:37\n";
#endif 
    

typedef union
{       
        struct
        {
        unsigned bit0   :1;
        unsigned bit1   :1;
        unsigned bit2   :1;
        unsigned bit3   :1;
        unsigned bit4   :1;
        unsigned bit5   :1;
        unsigned bit6   :1;
        unsigned bit7   :1;
        } BB;
        unsigned char BC;

} BITF;

/* #define DSP */
#define MAR 7 
#define MARA 5 
#define CNT 1 
#define CCNT 2 



main(int argc, char **argv)
{
	unsigned char buf[61000];
	int a,sz,b,c;

	printf("001 cb server ready\r\n");
	fflush(stdout);
	while (1)	{
		b = 0;
		for (a = 0; a < 100; a++)	{
			if (read(0,&c,1) != 1)
				exit(1);
			if (c == 10)
				break;
			buf[b++] = c;
			}
		buf[b] = 0;
		if (atoi(buf) == 0)	{
			printf("002 Thanks. Have a nice day\r\n");
			fflush(stdout);
			exit(1);
			}
		printf("003 Reading %d bytes\r\n",atoi(buf));
		fflush(stdout);
		sz = atoi(buf);
		a = slow_read(0,buf,sz);
		printf("Received %d bytes\r\n",a);
		fflush(stdout);
		c = 0;
		for (b = 0; b < 10; b++)	{
			sz = open("/dev/audio",O_WRONLY);
			if (sz >= 0)	{
				convert_data(sz,buf,a);
				printf("004 ok\r\n");
				close(sz);
				c = 1;
				break;
				}
			sleep(1);
			} 
		if (c == 0)
			printf("005 data lost\r\n");
		fflush(stdout);
		}
} 

convert_data(int hd, unsigned char *bu, int sz)
{
	unsigned char ch,la,by;
	char wil;
	char cnt[8];
	int aa,a,c; 
	BITF bit;
	int ladd,lsub,ud;
	int up,down;



	
	la = 0x80;
	c = 0;

	up = down = ud = ladd = lsub = 0;

	for (aa = 0; aa < sz; aa++)	{
		bit.BC = bu[aa];
		for (a = 0; a < 8; a++)
			cnt[a] = 0;

		if (bit.BB.bit0 == 1)
			cnt[0] = 1;
		if (bit.BB.bit1 == 1)
			cnt[1] = 1;
		if (bit.BB.bit2 == 1)
			cnt[2] = 1;
		if (bit.BB.bit3 == 1)
			cnt[3] = 1;
		if (bit.BB.bit4 == 1)
			cnt[4] = 1;
		if (bit.BB.bit5 == 1)
			cnt[5] = 1;
		if (bit.BB.bit6 == 1)
			cnt[6] = 1;
		if (bit.BB.bit7 == 1)
			cnt[7] = 1;

		for (a = 0; a < 8; a++)	{
			if (cnt[a] == 1)	{
				wil = '+';
				down = 0;
				up++;
				if (up < 1)
					up = 1;
				lsub -= MARA;
				if (lsub < 0)
					lsub = 0;
				ladd+=MAR;
				if (ladd > MAR)		{
					if (la + (ladd * up) > 0xff)	{
						la = 0xff;
						ladd-=MAR/2;
						up-=3;
						la = 0xa0;
						}
					else 
						la+=(ladd * up);
					}
				}

			else	{
				up = 0;
				wil = '-';
				down++;
				if (down < 1)
					down = 1;
				ladd -= MARA;
				if (ladd < 0)
					ladd = 0;
				lsub+=MAR;
				if (lsub > MAR)	{
					if (la - (lsub * down) < 0)	{
						down -= 3;
						lsub-=MAR/2;
						la = 0x30;
						la = 0;
						}
					else
						la -= (lsub * down);
					}
				}
/*			if ((la - 0x80) < 0)
				la = 0;
			else
				la-=0x80; */
#ifdef DSP
			write(1,&la,1);
#else
			ch = ulaw[la];
			write(hd,&ch,1);
/*			fprintf(stderr,"%x\n",la); */
#endif
			}
		}

}

slow_read(int hd, char *s, int sz)
{
    int pos;
    int a;
    int written = 0;
    int tz;
    
    pos = 0;
    tz = sz;  


    while (1)   {
        a = read(hd,&s[pos],tz);
        if (a < 0)
            return (-1);
        pos +=a;
        tz -= a;
#ifdef DEBUG
        printf("slow_read: have <%d> still want <%d>\n",pos,tz);
#endif
        if (pos >= sz)
            return (pos);
        }
}
